
Public MustInherit Class Animal

    Public MustOverride Function GetName() As String

End Class

Public Class Dog
    Inherits Animal

    Public Overrides Function GetName() As String
        Return "Dog"
    End Function
End Class

Public Class TestMustInherit
    Sub Main()
        'Dim spot As New Animal 'invalid, will not compile
        Dim spot As New Dog
        Dim myPet As Animal
        'nothing wrong with assigning a non-abstract child
        'to a variable of the parent type
        myPet = spot

        MsgBox(myPet.GetName) 'displays "Dog"
    End Sub
End Class

